com.fasterxml.jackson.databind.ser.impl

## Class StringArraySerializer

- java.lang.Object
- - com.fasterxml.jackson.databind.JsonSerializer<T>
  - - com.fasterxml.jackson.databind.ser.std.StdSerializer<T>
    - - com.fasterxml.jackson.databind.ser.ContainerSerializer<T>
      - - com.fasterxml.jackson.databind.ser.std.ArraySerializerBase<String[]>
        - - com.fasterxml.jackson.databind.ser.impl.StringArraySerializer

All Implemented Interfaces:
  JsonFormatVisitable, SchemaAware, ContextualSerializer, Serializable

    public class StringArraySerializer
    extends ArraySerializerBase<String[]>
    implements ContextualSerializer

Standard serializer used for `String[]` values.

See Also:
  Serialized Form

### Nested Class Summary

### Nested classes/interfaces inherited from class com.fasterxml.jackson.databind.JsonSerializer

`JsonSerializer.None`

### Field Summary

Fields
`protected JsonSerializer<Object>` `_elementSerializer` Value serializer to use, if it's not the standard one (if it is we can optimize serialization a lot)
`static StringArraySerializer` `instance`

### Fields inherited from class com.fasterxml.jackson.databind.ser.std.ArraySerializerBase

`_property, _unwrapSingle`

### Fields inherited from class com.fasterxml.jackson.databind.ser.std.StdSerializer

`_handledType`

### Constructor Summary

Constructors
`protected` `StringArraySerializer()`
`` `StringArraySerializer(StringArraySerializer src, BeanProperty prop, JsonSerializer<?> ser, Boolean unwrapSingle)`

### Method Summary

Methods
`JsonSerializer<?>` `_withResolved(BeanProperty prop, Boolean unwrapSingle)`
`ContainerSerializer<?>` `_withValueTypeSerializer(TypeSerializer vts)` Strings never add type info; hence, even if type serializer is suggested, we'll ignore it...
`void` `acceptJsonFormatVisitor(JsonFormatVisitorWrapper visitor, JavaType typeHint)` Default implementation specifies no format.
`JsonSerializer<?>` `createContextual(SerializerProvider provider, BeanProperty property)` Method called to see if a different (or differently configured) serializer is needed to serialize values of specified property.
`JsonSerializer<?>` `getContentSerializer()` Accessor for serializer used for serializing contents (List and array elements, Map values etc) of the container for which this serializer is used, if it is known statically.
`JavaType` `getContentType()` Accessor for finding declared (static) element type for type this serializer is used for.
`JsonNode` `getSchema(SerializerProvider provider, Type typeHint)` Default implementation simply claims type is "string"; usually overriden by custom serializers.
`boolean` `hasSingleElement(String[] value)` Method called to determine if the given value (of type handled by this serializer) contains exactly one element.
`boolean` `isEmpty(SerializerProvider prov, String[] value)` Method called to check whether given serializable value is considered "empty" value (for purposes of suppressing serialization of empty values).
`void` `serialize(String[] value, JsonGenerator gen, SerializerProvider provider)` Method that can be called to ask implementation to serialize values of type this serializer handles.
`void` `serializeContents(String[] value, JsonGenerator gen, SerializerProvider provider)`

### Methods inherited from class com.fasterxml.jackson.databind.ser.std.ArraySerializerBase

`serializeWithType`

### Methods inherited from class com.fasterxml.jackson.databind.ser.ContainerSerializer

`hasContentTypeAnnotation, isEmpty, withValueTypeSerializer`

### Methods inherited from class com.fasterxml.jackson.databind.ser.std.StdSerializer

`createObjectNode, createSchemaNode, createSchemaNode, findAnnotatedContentSerializer, findConvertingContentSerializer, findFormatFeature, findFormatOverrides, findPropertyFilter, getSchema, handledType, isDefaultSerializer, visitArrayFormat, visitArrayFormat, visitFloatFormat, visitIntFormat, visitIntFormat, visitStringFormat, visitStringFormat, wrapAndThrow, wrapAndThrow`

### Methods inherited from class com.fasterxml.jackson.databind.JsonSerializer

`getDelegatee, isUnwrappingSerializer, properties, replaceDelegatee, unwrappingSerializer, usesObjectId, withFilterId`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Field Detail

#### instance

    public static final StringArraySerializer instance

#### _elementSerializer

    protected final JsonSerializer<Object> _elementSerializer

Value serializer to use, if it's not the standard one (if it is we can optimize serialization a lot)

### Constructor Detail

#### StringArraySerializer

    protected StringArraySerializer()

#### StringArraySerializer

    public StringArraySerializer(StringArraySerializer src,
                         BeanProperty prop,
                         JsonSerializer<?> ser,
                         Boolean unwrapSingle)

### Method Detail

#### _withResolved

    public JsonSerializer<?> _withResolved(BeanProperty prop,
                                  Boolean unwrapSingle)

Specified by:
  `_withResolved` in class `ArraySerializerBase<String[]>`

#### _withValueTypeSerializer

    public ContainerSerializer<?> _withValueTypeSerializer(TypeSerializer vts)

Strings never add type info; hence, even if type serializer is suggested, we'll ignore it...

Specified by:
  `_withValueTypeSerializer` in class `ContainerSerializer<String[]>`

#### createContextual

    public JsonSerializer<?> createContextual(SerializerProvider provider,
                                     BeanProperty property)
                                       throws JsonMappingException

Description copied from interface: `ContextualSerializer`
Method called to see if a different (or differently configured) serializer is needed to serialize values of specified property. Note that instance that this method is called on is typically shared one and as a result method should NOT modify this instance but rather construct and return a new instance. This instance should only be returned as-is, in case it is already suitable for use.

Specified by:
  `createContextual` in interface `ContextualSerializer`
Overrides:
  `createContextual` in class `ArraySerializerBase<String[]>`
Parameters:
  `provider` - Serializer provider to use for accessing config, other serializers
  `property` - Method or field that represents the property (and is used to access value to serialize). Should be available; but there may be cases where caller can not provide it and null is passed instead (in which case impls usually pass 'this' serializer as is)
Returns:
  Serializer to use for serializing values of specified property; may be this instance or a new instance.
Throws:
  `JsonMappingException`

#### getContentType

    public JavaType getContentType()

Description copied from class: `ContainerSerializer`
Accessor for finding declared (static) element type for type this serializer is used for.

Specified by:
  `getContentType` in class `ContainerSerializer<String[]>`

#### getContentSerializer

    public JsonSerializer<?> getContentSerializer()

Description copied from class: `ContainerSerializer`
Accessor for serializer used for serializing contents (List and array elements, Map values etc) of the container for which this serializer is used, if it is known statically. Note that for dynamic types this may return null; if so, caller has to instead use `ContainerSerializer.getContentType()` and `SerializerProvider.findValueSerializer(java.lang.Class<?>, com.fasterxml.jackson.databind.BeanProperty)`.

Specified by:
  `getContentSerializer` in class `ContainerSerializer<String[]>`

#### isEmpty

    public boolean isEmpty(SerializerProvider prov,
                  String[] value)

Description copied from class: `JsonSerializer`
Method called to check whether given serializable value is considered "empty" value (for purposes of suppressing serialization of empty values).

Default implementation will consider only null values to be empty.

NOTE: replaces `JsonSerializer.isEmpty(Object)`, deprecated in 2.5

Overrides:
  `isEmpty` in class `JsonSerializer<String[]>`

#### hasSingleElement

    public boolean hasSingleElement(String[] value)

Description copied from class: `ContainerSerializer`
Method called to determine if the given value (of type handled by this serializer) contains exactly one element.

Note: although it might seem sensible to instead define something like "getElementCount()" method, this would not work well for containers that do not keep track of size (like linked lists may not).

Specified by:
  `hasSingleElement` in class `ContainerSerializer<String[]>`

#### serialize

    public final void serialize(String[] value,
                 JsonGenerator gen,
                 SerializerProvider provider)
                         throws IOException

Description copied from class: `JsonSerializer`
Method that can be called to ask implementation to serialize values of type this serializer handles.

Overrides:
  `serialize` in class `ArraySerializerBase<String[]>`
Parameters:
  `value` - Value to serialize; can not be null.
  `gen` - Generator used to output resulting Json content
  `provider` - Provider that can be used to get serializers for serializing Objects value contains, if any.
Throws:
  `IOException`

#### serializeContents

    public void serializeContents(String[] value,
                         JsonGenerator gen,
                         SerializerProvider provider)
                           throws IOException

Specified by:
  `serializeContents` in class `ArraySerializerBase<String[]>`
Throws:
  `IOException`

#### getSchema

    public JsonNode getSchema(SerializerProvider provider,
                     Type typeHint)

Description copied from class: `StdSerializer`
Default implementation simply claims type is "string"; usually overriden by custom serializers.

Specified by:
  `getSchema` in interface `SchemaAware`
Overrides:
  `getSchema` in class `StdSerializer<String[]>`
Parameters:
  `provider` - The serializer provider.
  `typeHint` - A hint about the type.
Returns:
  Json-schema for this serializer.

#### acceptJsonFormatVisitor

    public void acceptJsonFormatVisitor(JsonFormatVisitorWrapper visitor,
                               JavaType typeHint)
                                 throws JsonMappingException

Description copied from class: `StdSerializer`
Default implementation specifies no format. This behavior is usually overriden by custom serializers.

Specified by:
  `acceptJsonFormatVisitor` in interface `JsonFormatVisitable`
Overrides:
  `acceptJsonFormatVisitor` in class `StdSerializer<String[]>`
  `typeHint` - Type of element (entity like property) being visited
Throws:
  `JsonMappingException`